#ifndef _SENTENCE_H_
#define _SENTENCE_H_

/*
 * Structure providing an easy access to individual words in a sentence.
 */

union wids_s;
struct lmi_s;


typedef struct sentence_s {
    char * str;         /* stores the raw sentence */
    char * words_buffer; /* internal : words separated by the null character */
    char ** words;      /* array indexing the words above; use this */
    int wordCount;

  /* If using a language model, the word indices are stored in those arrays  */
    union wid_s * wids;
    union wid_s * wids_back;  /* for a backward LM (used in confidence measures) */
} sentence_t;



/* Creates a new sentence_t from string s;
 * sets all fields but the wids ones. (does not store s) */
sentence_t* sentence_new(const char *s);
/* Frees all memory allocated by sentence_new */
void sentence_free(sentence_t *s);

/* Sets the wids in a sentence */
void sentence_set_wids(sentence_t *s, const struct lmi_s *lm, const struct lmi_s *back_lm);

char * sentence_get_string(sentence_t *);

#endif
