/*
Copyright (c) 2011, Sylvain Raybaud <sylvain.raybaud@gmail.com>
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of the PAROLE team, LORIA, INRIA nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <unistd.h>

#include "maparole.h"
#include "common.h"


#define DEFAULT_HMM MODELDIR "/hmm/en_US/hub4wsj_sc_8k"
#define DEFAULT_LM MODELDIR "/lm/en/turtle.DMP"
#define DEFAULT_DICT MODELDIR "/lm/en/turtle.dic"

void mp_parse_cfg_ps(mp_config_t * cfg, const char * cfgfilename) {
    
    
    /*
    CL switches override specified config files which override default config file 
    which override buil-in defaults
    */
    
    //cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),TRUE,"-lw", cfg->ps_config.lw,NULL);
    //cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),TRUE,NULL);
    
    if(access("ps.cfg", F_OK)==0)
        cfg->ps_config.ps_cmd_ln = cmd_ln_parse_file_r(NULL,ps_args(),"ps.cfg",FALSE);
    if(cfgfilename && access(cfgfilename, F_OK)==0)
        cfg->ps_config.ps_cmd_ln = cmd_ln_parse_file_r(NULL,ps_args(),cfgfilename,FALSE);
    
    if(cfg->ps_config.hmm_filename)
        cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),FALSE,"-hmm", cfg->ps_config.hmm_filename,NULL);
    if(cfg->ps_config.dict_filename)
        cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),FALSE,"-dict", cfg->ps_config.dict_filename,NULL);
    if(cfg->ps_config.fdict_filename)
        cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),FALSE,"-fdict", cfg->ps_config.fdict_filename,NULL);
    if(cfg->ps_config.mdef_filename)
        cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),FALSE,"-mdef", cfg->ps_config.mdef_filename,NULL);
    
    cfg->ps_config.ps_cmd_ln = cmd_ln_init(cfg->ps_config.ps_cmd_ln,ps_args(),FALSE,"-lw", cfg->ps_config.lw_str,NULL);
    
    if (cfg->ps_config.ps_cmd_ln == NULL)
        exit(EXIT_PS_ERROR);
    
    return;
}

int mp_check_ps_config(mp_config_t * cfg) {
    /* We'll see later */
    return 0;
}

