/*
Copyright (c) 2011, Sylvain Raybaud <sylvain.raybaud@gmail.com>
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
Neither the name of the PAROLE team, LORIA, INRIA nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef _interface_moses_h_
#define _interface_moses_h_

#include <glib.h>

#include "maparole.h"
#include "engine.h"
#include <slf.h>

#ifdef __cplusplus
extern "C" {
#endif

/* wrappers around C++ code */

char * moses_translate(mp_config_t * config, mp_engine_t * engine, translation_pair_t * t);
// char * moses_translate_string(mp_config_t * config, mp_engine_t * engine, char const * ps_hyp);

/* return a pointer to a class instance (Parameter)*/
int moses_read_config_file(const char * moses_config_filename, moses_config_t * config);

void moses_terminate(moses_config_t * config);

/* returns 1 if moses static data were successfully loaded */
int moses_static_data(moses_config_t * config);

GRegex * mk_noise_re();
gboolean match_noise(GRegex*,const char *);

#ifdef __cplusplus
} /* extern "C" */
#endif


#endif /* _interface_moses_h_ */
