#include "fct.h"

#include "language_model.h"
#include "interface_moses.h"
#include "lattice.h"

#include <ps_lattice.h>

#include <glib.h>

static int first = 1, final = 0;

FCTMF_SUITE_BGN(test_lattice_suite) {
    
//     fprintf(stderr,"entering lattice test suite\n");
    logmath_t *lmath = NULL;
    sphinx_lm_t *sphinx_data = NULL;
    lmi_t sphinx_lm;
    ps_decoder_t * sphinx = NULL;
    
    moses_config_t cfg;
//     moses_lm_t *moses_data = NULL;
//     lmi_t moses_lm;
    
    FCT_SETUP_BGN() {
        if (first) {
//             fprintf(stderr,"init lattice test...\n");
            lmath = logmath_init(1.1, 0, 0);
            sphinx_data = sphinx_open_lm("tests/resources/toy.arpa", lmath);
            sphinx_lm = sphinx_lmi_new(sphinx_data);
            sphinx = ps_init(NULL);
            ps_update_lmset(sphinx,sphinx_data->lm);
            
            moses_read_config_file("tests/resources/moses.test_lm.ini", &cfg);
            moses_static_data(&cfg);
//             moses_data = moses_get_lm();
//             moses_lm = moses_lmi_new(moses_data);
            first = 0;
//             fprintf(stderr,"init lattice test: ok\n");
        }
    } FCT_SETUP_END();
    
    FCT_TEARDOWN_BGN() {
        if (final) {
            sphinx_lm.free_data(sphinx_lm.data);
            free(sphinx_lm.data);
            moses_terminate(&cfg);
            logmath_free(lmath);
        }
    } FCT_TEARDOWN_END();
    
    FCT_TEST_BGN(test_topo) {
//         fprintf(stderr,"starting test_topo\n");
        const char * w[] = {"a","b","c","d","e"};
        ps_lattice_t * lat = ps_lattice_read(sphinx,"tests/resources/toy.slf");
        GSList * sorted = ps_lattice_topological_sort(lat);
        for(int i=0; i<5 ; i++) {
            fct_chk_eq_str(ps_latnode_baseword(lat,sorted->data), w[i]);
            sorted = g_slist_next(sorted);
        }
    } FCT_TEST_END();
    
} FCTMF_SUITE_END();
